Add button to "Create and follow" when adding a subtask from the parent issue
Description

If | create a SubTask on a Parent - the first time | save it | land not on my new task but back on the parent. Subsequently if | edit the
subtask and save | remain on the subtask.

The initial behaviour is unexpected and unwelcome. Often half way through creating a task | realise | need to move it to a different
project (which you can only do after saving) and hit edit, to reassign and end up accidentally reasigning the parent. Other times |
realise | have made an error and end up editing the parent instead.

| don't understand the rationale for this behaviour - | find it unexpected and annoying?

Related issues:
Has duplicate Redmine - Defect #34594: Redmine 3.3.2 redirect after creating ... Closed

Associated revisions

Revision 21269 - 2021-11-06 10:11 - Marius BALTEANU

Adds button to "Create and follow" when adding a subtask from the parent issue. Now the user have the following options:
e Create: redirects the user to the parent task (existing behaviour)
¢ Create and follow: redirects the user to the newly created subtask (new behaviour)
¢ Create and add another: redirects the user to new subtask (existing behaviour).

(#29076).

Revision 21270 - 2021-11-06 20:38 - Marius BALTEANU
Update locales (#29076).

Revision 21272 - 2021-11-08 15:12 - Go MAEDA
Fix RuboCop offense Naming/MethodName due to r21269 (#29076).

History

#1 - 2018-06-21 14:45 - Go MAEDA

| am also annoyed by this behavior. Sometimes | mistakenly update a parent issue instead of a subtask.

#2 - 2018-06-25 16:58 - Holger Just

This behavior was introduced in r16317 released with Redmine 3.4.0

#3 - 2018-06-25 17:06 - Go MAEDA

- Affected version set to 3.4.0

#4 - 2018-07-05 01:41 - Go MAEDA
Go MAEDA wrote:

| am also annoyed by this behavior. Sometimes | mistakenly update a parent issue instead of a subtask.

But | realized that the current behavior is useful when you create subtasks for a particular issue one after another.

#6 - 2021-01-25 00:17 - Marius BALTEANU
- Related to Defect #34594: Redmine 3.3.2 redirect after creating issue broke added

#7 - 2021-01-25 00:17 - Marius BALTEANU
- Related to deleted (Defect #34594: Redmine 3.3.2 redirect after creating issue broke)

#8 - 2021-01-25 00:17 - Marius BALTEANU
- Has duplicate Defect #34594: Redmine 3.3.2 redirect after creating issue broke added

#9 - 2021-01-25 00:23 - Marius BALTEANU
Go MAEDA wrote:
Go MAEDA wrote:

| am also annoyed by this behavior. Sometimes | mistakenly update a parent issue instead of a subtask.

But | realized that the current behavior is useful when you create subtasks for a particular issue one after another.

Indeed, both use cases are valid.

What if we introduce a third button "Create and follow" and then the user will have all the options available:
1. Create -> creates the subtask and returns to parent

2. Create and follow -> creates the subtask and stays on the newly created issue (old behaviour)

3. Create and add another -> creates the subtasks and stays on the subtask form.

#10 - 2021-01-25 06:19 - Bernhard Rohloff

Marius BALTEANU wrote:
Go MAEDA wrote:
What if we introduce a third button "Create and follow" and then the user will have all the options available:
1. Create -> creates the subtask and returns to parent

2. Create and follow -> creates the subtask and stays on the newly created issue (old behaviour)
3. Create and add another -> creates the subtasks and stays on the subtask form.

| like the suggestion. These are three valid options and | think it would be a good thing if users could choose between them. From my point of view |
would rename Marius' first option to "Create and return" because the second option "Create and follow" is the default behavior of "Create" in other
cases and | would not mix them up.

So this would be my favorite order:

1. Create -> creates the subtask and stays on the newly created issue (old/default behaviour)

2. Create and return -> creates the subtask and returns to parent
3. Create and add another -> creates the subtasks and stays on the subtask form.

#11 - 2021-01-25 06:23 - Go MAEDA
Bernhard Rohloff wrote:
From my point of view | would rename Marius' first option to "Create and return" because the second option "Create and follow" is the default
behavior of "Create" in other cases and | would not mix them up.
| also think so.
So this would be my favorite order:
1. Create -> creates the subtask and stays on the newly created issue (old/default behaviour)

2. Create and return -> creates the subtask and returns to parent
3. Create and add another -> creates the subtasks and stays on the subtask form.

+1 for this.

#12 - 2021-01-25 08:57 - Bernhard Rohloff

- File mockup_create_and_return.png added

This is how it would look like...

2025-05-02 2/3



mockup_create_and_return.png
The list of buttons might get a bit too overwhelming depending on the length of the description text. Perhaps it would be beneficial to move the
additional options to a ... menu.

#13 - 2021-02-27 09:22 - Marius BALTEANU
- Assignee set to Marius BALTEANU

#14 - 2021-02-27 17:02 - Marius BALTEANU

- File 0001-Add-button-to-Create-and-follow-when-adding-a-subtas.patch added
- Tracker changed from Defect to Patch

- Assignee deleted (Marius BALTEANU)

- Target version set to Candidate for next major release

Thanks Bernhard for you feedback. | tried to implement as you proposed, but it requires more changes in the redirect_after_create method from
IssuesController in order for the button "Create" to behave differently depending on the params (I can provide more details, if you want).

Considering that we already have the term "follow" (Move and follow, Copy and follow), I've added the "Create and follow" option which required only
few lines of code, please see the attached patch.

#15 - 2021-09-14 11:26 - Ewan Makepeace

| really dont care about all the fancy options - they would be nice, but | am STILL routinely editing the parent task instead of the just created task on a
routine basis. This is really annoying me.

#16 - 2021-11-06 20:43 - Marius BALTEANU

- Subject changed from Dont return to Parent Task on Submit to Add button to "Create and follow" when adding a subtask from the parent issue

- Status changed from New to Closed

- Assignee set to Marius BALTEANU

- Target version changed from Candidate for next major release to 5.0.0
Patch committed. You can now use the button "Create and follow" to stay on the newly created subtask.

#17 - 2022-03-27 05:00 - Go MAEDA

- Tracker changed from Patch to Feature

Files
mockup_create_and_return.png 74.3 KB 2021-01-25 Bernhard Rohloff
0001-Add-button-to-Create-and-follow-when-adding-a-subtas.patch 3.6 KB 2021-02-27 Marius BALTEANU
